using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MaxiBioInterfaceLibrary;

namespace MaxiBioWindowsApplication
{
    public partial class BioGrafSalForm : Form
    {
        private IBiograf aktuelBiograf;
        private IBiografsal aktuelBiografsal;

        public BioGrafSalForm(IBiograf initBiograf, IBiografsal initBiografsal)
        {
            InitializeComponent();

            //this.aktuelBiograf = new Biograf("Test Biograf");
            //this.txtBiografnavn.Text = this.aktuelBiograf.Biografnavn;
            this.aktuelBiograf = initBiograf;
            this.aktuelBiografsal = initBiografsal;
            if (this.aktuelBiograf != null)
            {
                // fyld data i gui
                this.txtBiografnavn.Text = this.aktuelBiograf.Biografnavn;
            }
            if (this.aktuelBiografsal != null)
            {
                this.txtSalnavn.Text = this.aktuelBiografsal.Navn;
                this.txtAntalpladser.Text = this.aktuelBiografsal.AntalPladser.ToString();
                this.chkThx.Checked = this.aktuelBiografsal.Thx;

                this.fyldForestillingListBox();
            }
        }

        private void fyldForestillingListBox()
        {
            IForestilling[] alleForestillinger = this.aktuelBiografsal.HentAlleForestillinger();
            this.lbxForestillinger.Items.Clear();
            this.lbxForestillinger.Items.AddRange(alleForestillinger);
        }

        private void btnOpretSal_Click(object sender, EventArgs e)
        {
            string salnavn = this.txtSalnavn.Text;
            int antalPladser = int.Parse(this.txtAntalpladser.Text);
            bool thx = this.chkThx.Checked;
            this.aktuelBiografsal = 
                this.aktuelBiograf.OpretBiografsal(salnavn, thx, antalPladser);
        }

        private void btnFindSal_Click(object sender, EventArgs e)
        {
            string salnavn = this.txtSalnavn.Text;
            IBiografsal fundetSal = this.aktuelBiograf.FindBiografsal(salnavn);
            if (fundetSal != null)
            {
                this.aktuelBiografsal = fundetSal;
                this.txtSalnavn.Text = this.aktuelBiografsal.Navn;
                this.txtAntalpladser.Text = this.aktuelBiografsal.AntalPladser.ToString();
                this.chkThx.Checked = this.aktuelBiografsal.Thx;
            }
            else
            {
                MessageBox.Show("Sal findes ikke");
                this.aktuelBiografsal = null;
            }
        }

        private void BtnRetSal_Click(object sender, EventArgs e)
        {
            if (this.aktuelBiografsal == null)
            {
                MessageBox.Show("Find frst en sal");
            }
            else
            {
                // gr data klar fra form
                string salnavn = this.txtSalnavn.Text;
                int antalPladser = int.Parse(this.txtAntalpladser.Text);
                bool thx = this.chkThx.Checked;
                // opdater biografsalsobjektet
                this.aktuelBiografsal.Navn = salnavn;
                this.aktuelBiografsal.Thx = thx;
                this.aktuelBiografsal.AntalPladser = antalPladser;
            }
        }

        private void lbxForestillinger_SelectedIndexChanged(object sender, EventArgs e)
        {
            IForestilling valgtForestilling = lbxForestillinger.SelectedItem as IForestilling;
            ForestillingForm foForm = new ForestillingForm(this.aktuelBiografsal, valgtForestilling);
            foForm.ShowDialog();

            this.fyldForestillingListBox(); // data kan vre ndret s vi fylder ind igen 
        }
    }
}