using System;
using System.Collections.Generic;
using System.Text;
using MaxiBioInterfaceLibrary;

namespace MaxiBioClassLibrary
{
    class Forestilling : IForestilling
    {
        #region felter for "selve" Forestilling klassen
        private int dato;           // aaaammdd
        private int tidspunkt;      // hhmm
        private bool aflyst;
        #endregion

        #region properties for "selve" Forestilling klassen
        public int Dato
        {
            get { return this.dato; }
            set { this.dato = value; }
        }
        public int Tidspunkt
        {
            get { return this.tidspunkt; }
            set { this.tidspunkt = value; }
        }
        public bool Aflyst
        {
            get { return this.aflyst; }
            set { this.aflyst = value; }
        }
        #endregion

        #region metoder der kun vedrrer Forstilling klassen
        public Forestilling(int initDato, int initTidspunkt)
        {
            this.dato = initDato;
            this.tidspunkt = initTidspunkt;
        }
        #endregion

        #region felter og metoder for tilknytningen til Film klassen
        private IFilm filmen = null;        // den tilknyttede film

        public Forestilling(int initDato, int initTidspunkt, IFilm initFilm)
        {
            this.dato = initDato;
            this.tidspunkt = initTidspunkt;
            this.filmen = initFilm;         // film tilknyttes ved oprettelsen
        }


        public void TilknytFilm(IFilm enFilm)
        {
            this.filmen = enFilm;       // evt. tidligere udskiftes
        }

        public IFilm HentTillnyttetFilm()
        {
            return this.filmen;
        }
        #endregion

        public override string ToString()
        {
            if (this.filmen == null)
                return "" + this.dato + ";" + this.tidspunkt;
            return "" + this.dato + ";" + this.tidspunkt + ";" + this.filmen.Titel;
    }
    }
}
