using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MaxiBioInterfaceLibrary;

namespace MaxiBioWindowsApplication
{
    public partial class BiografForm : Form
    {
        private IMaxiBio aktuelMaxiBio;
        private IBiograf aktuelBiograf;

        public BiografForm(IMaxiBio initMaxiBio, IBiograf initBiograf)
        {
            InitializeComponent();

            // opret test objekt
            //this.aktuelMaxiBio = new MaxiBio();
            this.aktuelMaxiBio = initMaxiBio;
            this.aktuelBiograf = initBiograf;
            if (this.aktuelBiograf != null)
            {
                this.txtBiografnavn.Text = this.aktuelBiograf.Biografnavn;
                this.fyldBiografsalListBox();
            }
        }

        private void fyldBiografsalListBox()
        {
            IBiografsal[] sale = this.aktuelBiograf.HentAlleBiografsale();
            this.lbxBiografsale.Items.Clear();
            this.lbxBiografsale.Items.AddRange(sale);
        }

        private void btnOpretBiograf_Click(object sender, EventArgs e)
        {
            string biografnavn = this.txtBiografnavn.Text;
            this.aktuelBiograf = this.aktuelMaxiBio.OpretBiograf(biografnavn);
            this.fyldBiografsalListBox();
        }

        private void btnFindBiograf_Click(object sender, EventArgs e)
        {
            string biografnavn = this.txtBiografnavn.Text;
            this.aktuelBiograf = this.aktuelMaxiBio.FindBiograf(biografnavn);
            if (this.aktuelBiograf == null)
            {
                MessageBox.Show("Biograf findes ikke");
            }
            else
            {
                this.fyldBiografsalListBox();
            }
        }

        private void btnRetBiograf_Click(object sender, EventArgs e)
        {
            if (this.aktuelBiograf == null)
            {
                MessageBox.Show("Du skal frst finde biograf");
            }
            else
            {
                string biografnavn = this.txtBiografnavn.Text;
                this.aktuelBiograf.Biografnavn = biografnavn;
            }
        }

        private void btnTilSale_Click(object sender, EventArgs e)
        {
            BioGrafSalForm bioSalForm =
                new BioGrafSalForm(this.aktuelBiograf, null);
            bioSalForm.ShowDialog();
        }

        private void lbxBiografsale_SelectedIndexChanged(object sender, EventArgs e)
        {
            IBiografsal valgtSal =
                this.lbxBiografsale.SelectedItem as IBiografsal;
            BioGrafSalForm salForm =
                new BioGrafSalForm(this.aktuelBiograf, valgtSal);
            salForm.ShowDialog();

            fyldBiografsalListBox(); // da data kan vre ndret fyldes op igen
        }
    }
}