using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MaxiBioInterfaceLibrary;
using MaxiBioClassLibrary;

namespace MaxiBioWindowsApplication
{
    public partial class MaxiBioMainForm : Form
    {
        private IMaxiBio aktuelMaxiBio;

        public MaxiBioMainForm()
        {
            InitializeComponent();
            //this.aktuelMaxiBio = new MaxiBio();
            MaxiBioFasade.OpretMaxiBioMedTestData();
            this.aktuelMaxiBio = MaxiBioFasade.GetMaxiBioObjektet();
            this.fyldBiografListBox();
        }

        private void btnTilBigrafForm_Click(object sender, EventArgs e)
        {
            BiografForm bioForm = 
                new BiografForm(this.aktuelMaxiBio,null);
            bioForm.ShowDialog();
        }
        private void fyldBiografListBox()
        {
            IBiograf[] alleBiografer = this.aktuelMaxiBio.HentAlleBiografer();
            this.lbxBiografer.Items.Clear();
            this.lbxBiografer.Items.AddRange(alleBiografer);
        }

        private void btnFyldBiografListBox_Click(object sender, EventArgs e)
        {
            this.fyldBiografListBox();
        }

        private void lbxBiografer_SelectedIndexChanged(object sender, EventArgs e)
        {
            IBiograf valgtBiograf =
                this.lbxBiografer.SelectedItem as IBiograf;
            // (Biograf)this.lbxBiografer.SelectedItem;
            BiografForm bioForm =
                new BiografForm(this.aktuelMaxiBio, valgtBiograf);
            bioForm.ShowDialog();

        }

        private void btnTilFilmForm_Click(object sender, EventArgs e)
        {
            FilmForm fForm = new FilmForm(this.aktuelMaxiBio);
            fForm.ShowDialog();
        }

        private void btnTilFilmFormUdenMaxiBioObjekt_Click(object sender, EventArgs e)
        {
            // Her overfres MaxiBio objektet ikke som parameter
            // Da objektet ligger i MaxiBioFasade klassen som static
            // kan FilmForm skaffe sig objektet via MaxiBioFasade klassen
            FilmForm fForm = new FilmForm();
            fForm.ShowDialog();
        }
    }
}